package parser

import (
	"errors"
	"fmt"

	occfg "github.com/qsfera/server/pkg/config"
	defaults2 "github.com/qsfera/server/pkg/config/defaults"
	"github.com/qsfera/server/pkg/config/envdecode"
	"github.com/qsfera/server/pkg/shared"
	"github.com/qsfera/server/services/gateway/pkg/config"
	"github.com/qsfera/server/services/gateway/pkg/config/defaults"
)

// ParseConfig loads configuration from known paths.
func ParseConfig(cfg *config.Config) error {
	err := occfg.BindSourcesToStructs(cfg.Service.Name, cfg)
	if err != nil {
		return err
	}

	defaults.EnsureDefaults(cfg)

	// load all env variables relevant to the config in the current context.
	if err := envdecode.Decode(cfg); err != nil {
		// no environment variable set for this config is an expected "error"
		if !errors.Is(err, envdecode.ErrNoTargetFieldsAreSet) {
			return err
		}
	}

	defaults.Sanitize(cfg)

	return Validate(cfg)
}

func Validate(cfg *config.Config) error {
	if cfg.TokenManager.JWTSecret == "" {
		return shared.MissingJWTTokenError(cfg.Service.Name)
	}

	if cfg.TransferSecret == "" {
		return shared.MissingRevaTransferSecretError(cfg.Service.Name)
	}

	if cfg.StorageRegistry.StorageUsersMountID == "" {
		return fmt.Errorf("The storage users mount ID has not been configured for %s. "+
			"Make sure your %s config contains the proper values "+
			"(e.g. by running qsfera init or setting it manually in "+
			"the config/corresponding environment variable).",
			"gateway", defaults2.BaseConfigPath())
	}

	return nil
}
